; 
    include \masm32\include\masm32rt.inc
; 

.data

    hWnd      dd 0
    hInstance dd 0
    lpCmdLine dd 0
    screen_w  dd 0
    screen_h  dd 0
    mouse_pt  dd 0
    idQuake   dd 0
    hQThread  dd 0
    bRunning  dd 0
    hDC       dd 0
    hdcCompat dd 0
    hdcScreen dd 0
    hbmScreen dd 0
    szDisplay db "DISPLAY",0
    ClassName db "QuakeWindowClass",0
    AppName   db "Quake Display Hack",0

.code

Quake proc

        LOCAL w :DWORD, h :DWORD, x :DWORD, y :DWORD, x1 :DWORD, y1 :DWORD

        mov ebx, 60
@@:
        mov eax, screen_w           ; width less than one-forth of screen
        shr eax, 2
        invoke nrandom, eax
        add eax, 1
        mov w, eax

        mov eax, screen_h           ; height less than one-eigth of screen
        shr eax, 3
        invoke nrandom, eax
        add eax, 1
        mov h, eax

        mov eax, screen_w           ; top-left-x
        sub eax, 1
        sub eax, w
        invoke nrandom, eax
        add eax, 1
        mov x, eax

        mov eax, screen_h           ; top-left-y
        sub eax, 2
        sub eax, h
        invoke nrandom, eax
        add eax, 2
        mov y, eax

        mov eax, 3                  ; destination top-left-x
        invoke nrandom, eax
        sub eax, 1
        add eax, x
        mov x1, eax

        mov eax, 3                  ; destination top-left-y
        invoke nrandom, eax
        sub eax, 1
        add eax, y
        mov y1, eax

        invoke BitBlt,hdcScreen,x,y,w,h,hdcScreen,x1,y1,SRCCOPY      

        sub ebx, 1
        jnz @B

        ret

Quake endp

QuakeThread:

    invoke GetDC, 0
    mov    hDC, eax
    invoke CreateDC,ADDR szDisplay, NULL, NULL, NULL
    mov    hdcScreen, eax
    invoke CreateCompatibleDC, hdcScreen
    mov    hdcCompat, eax
    invoke CreateCompatibleBitmap, hdcScreen, screen_w,screen_h
    mov    hbmScreen, eax
    invoke SelectObject, hdcCompat, hbmScreen

    mov    bRunning, 1

    invoke SetThreadPriority,idQuake,THREAD_PRIORITY_IDLE

@@:
    call   Quake
    invoke Sleep, 5
    mov    eax,bRunning
    test   eax, eax
    jne    @B

    invoke DeleteObject, hdcCompat
    invoke DeleteObject, hbmScreen
    invoke DeleteDC, hdcScreen
    invoke InvalidateRect, 0, 0, FALSE
    invoke UpdateWindow, 0
    invoke ReleaseDC, 0, hDC

    mov    idQuake, -1
    invoke ExitThread, 0


WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc PROTO :DWORD, :DWORD, :DWORD, :DWORD

; 
start:
; 

    invoke GetModuleHandle,NULL
    mov    hInstance,eax
    invoke GetSystemMetrics, SM_CXSCREEN
    mov    screen_w, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    mov    screen_h, eax
    invoke GetCommandLine
    mov    lpCmdLine, eax

    invoke CreateThread,0,4096,ADDR QuakeThread,0,0,ADDR idQuake
    mov    hQThread,eax

    invoke WinMain,hInstance,NULL,lpCmdLine,SW_SHOWNORMAL

    invoke ExitProcess, 0

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL  wc:WNDCLASSEX
    LOCAL  msg:MSG

    mov    wc.cbSize,sizeof WNDCLASSEX
    mov    wc.style,CS_HREDRAW or CS_VREDRAW
    mov    wc.lpfnWndProc,offset WndProc
    mov    wc.cbClsExtra,NULL
    mov    wc.cbWndExtra,NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground,NULL
    mov    wc.lpszMenuName,NULL
    mov    wc.lpszClassName,offset ClassName
    mov    wc.hIcon,NULL
    mov    wc.hIconSm,NULL
    invoke LoadCursor,NULL,IDC_ARROW
    mov    wc.hCursor,eax
    invoke RegisterClassEx,addr wc
    invoke CreateWindowEx,WS_EX_TRANSPARENT or WS_EX_TOPMOST, \
                          ADDR ClassName, ADDR AppName, \
                          WS_OVERLAPPED, CW_USEDEFAULT,\
                          CW_USEDEFAULT, screen_w, screen_h, NULL, NULL, \
                          hInstance,NULL
    mov    hWnd, eax

    invoke ShowWindow,hWnd,SW_SHOWNORMAL
    invoke UpdateWindow,hWnd

    .while TRUE
        invoke GetMessage,addr msg,NULL,0,0
        .BREAK .if !eax
        invoke TranslateMessage,addr msg
        invoke DispatchMessage,addr msg
    .endw

    mov    eax,msg.wParam
    ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    .if uMsg==WM_MOUSEMOVE
        mov    eax, lParam
        xchg   eax, mouse_pt
        cmp    eax, mouse_pt
        je     @F
        test   eax, eax
        jz     @F
        invoke SendMessage,hWin,WM_CLOSE,0,0
     @@:
    .elseif uMsg==WM_KEYDOWN
        invoke SendMessage,hWin,WM_CLOSE,0,0
    .elseif uMsg==WM_RBUTTONDOWN
        invoke SendMessage,hWin,WM_CLOSE,0,0
    .elseif uMsg==WM_LBUTTONDOWN
        invoke SendMessage,hWin,WM_CLOSE,0,0
    .elseif uMsg==WM_CLOSE
        mov    bRunning,0
        invoke SetThreadPriority,idQuake,THREAD_PRIORITY_HIGHEST
        invoke DestroyWindow,hWin
    .elseif uMsg==WM_DESTROY
        invoke PostQuitMessage,NULL
    .else
        invoke DefWindowProc,hWin,uMsg,wParam,lParam
        ret
    .endif

    xor    eax,eax
    ret

WndProc endp

end start

